<template>
  <div class="container-xl">
    <button type="button" class="btn btn-warning dropdown-toggle mb-3" data-bs-toggle="dropdown" aria-expanded="false">
      {{ currentF.nomFournisseur }} 
    </button>
    <ul class="dropdown-menu scrollable-menu">
      <li ><a class="dropdown-item" v-for="item in fournisseurs" :key="item.codeFournisseur" @click="getCurrentFour(item.codeFournisseur)"><i>{{ item.q }}</i> - {{ item.nomFournisseur }}</a></li>
    </ul>
    <div class="row">
      <div class="col-xl-3 col-md-6 mb-4">
          <div class="card border-left-primary shadow h-100 py-2">
              <div class="card-body">
                  <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                          <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">
                            À commander</div>
                          <div class="h5 mb-0 font-weight-bold text-gray-800">{{ info.articlesCount }} pièces
                            <br/> {{ info.refCount }} références</div>
                      </div>
                      <div class="col-auto">
                          <i class="fas fa-calendar fa-2x text-gray-300"></i>
                      </div>
                  </div>
              </div>
          </div>
      </div>

      <div class="col-xl-3 col-md-6 mb-4">
          <div class="card border-left-success shadow h-100 py-2">
              <div class="card-body">
                  <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                          <div class="text-xs font-weight-bold text-success text-uppercase mb-1">
                              Total €</div>
                          <div class="h5 mb-0 font-weight-bold text-gray-800"><p>PA HT : {{ info.totalPaHT }} €<br />PV HT : {{ info.totalPvTTC }} €</p></div>
                      </div>
                  </div>
              </div>
          </div>
      </div>
    </div>
  </div>

  <EasyDataTable
    buttons-pagination
    :headers="headers"
    :items="items"
    :loading="loading"
    theme-color="#216155"
    table-class-name="customize-table"
  >
    <template #loading>
      <img
        src="https://i.pinimg.com/originals/94/fd/2b/94fd2bf50097ade743220761f41693d5.gif"
        style="width: 100px; height: 80px;"
      />
    </template>
    <template #item-seostars="{seostars}">
      <font-awesome-icon icon="fa-solid fa-star" style="color:#FA0" v-for="n in seostars" :key="n"/>
      <font-awesome-icon icon="fa-solid fa-star" style="color:#AAA" v-for="n in ( 5 - seostars)" :key="n"/>
    </template>
    <template #item-statut="{statut}">
      <span class="badge bg-danger" v-if="(statut !== 'Commercialisé')">NON</span>
      <span class="badge bg-success" v-else>OUI</span>
    </template>
    <template #item-dispo_fournisseur="{dispo_fournisseur}">
      <span class="badge bg-danger" v-if="(dispo_fournisseur === 0)">NON</span>
      <span class="badge bg-success" v-else>OUI</span>
    </template>
    <template #item-coef_progression="{coef_progression,METHODE_VENTE}">
      <div class="d-flex flex-row">
        <b v-if="(METHODE_VENTE !== 'SUR_COMMANDE')">{{ coef_progression }}</b>
        <div class="ms-2">
          <font-awesome-icon icon="fa-solid fa-arrow-up" style="color:#69b145" v-if="(coef_progression > 2)"/>
          <font-awesome-icon icon="fa-solid fa-arrow-down" style="color:#F80" v-else-if="(coef_progression < 2)"/>
          <font-awesome-icon icon="fa-solid fa-equals" class="text-secondary" v-else-if="(coef_progression == 2)"/>
        </div>
      </div>
      
    </template>
    <template #item-achats_saison="{achats_saison,prev_saison}">
      <span class="badge bg-danger" title="100% consommé" v-if="(achats_saison >= prev_saison )">{{ achats_saison }}</span>
      <span class="badge bg-warning" title="100% consommé" v-else-if="(achats_saison > 0 && prev_saison > 0 && (achats_saison / prev_saison) > 0.8 )">{{ achats_saison }}</span>
      <span class="badge bg-warning" v-else >{{ achats_saison }} </span> 
      </template>
  </EasyDataTable>


  <input type="checkbox" id="showblock"/>
  <div id="slideout">
    <label id="slideout_tab" for="showblock" title="Admin Slider">
      <font-awesome-icon icon="fa-solid fa-file-excel" />
    </label>
    <div id="slideout_inner">
      <div class="d-flex flex-row mb-3">
          <div>
            <div style="display:inline-block; width:40px;text-align:center;color:#FFF" class="ms-2">
              <a class="datadownload" href="{{ $downloadurl0 }}" downloadurl="{{ $downloadurl0 }}"
                title="Télécharger les données Excel" style="color:#F00"><font-awesome-icon icon="fa-solid fa-file-excel" /></a>
              <div style="width:40px">Rupt.</div>
            </div>
          </div>
          <div>
            <div style="display:inline-block; width:40px;text-align:center;color:#FFF" class="me-2 ms-2">
                <a class="datadownload me-2 ms-2" href="{{ $downloadurl }}" downloadurl="{{ $downloadurl }}"
                    title="Télécharger les données Excel"><font-awesome-icon style="color:#FFF" icon="fa-solid fa-file-excel" /></a>
                <div style="width:40px">x1</div>
            </div>
          </div>
          <div>
            <div style="display:inline-block; width:40px;text-align:center;color:#FFF">
                <a class="datadownload" href="{{ $downloadurl }}" downloadurl="{{ $downloadurl }}"
                    title="Télécharger les données Excel"><font-awesome-icon style="color:#FFF" icon="fa-solid fa-file-excel" /></a>
                <div style="width:40px">x3</div>
            </div>
          </div>
        </div>
    </div>
  </div>
</template>

<script  lang="ts">
import { defineComponent, ref, reactive, watch  } from "vue";
import { Header, Item } from "vue3-easy-data-table";
import { getFournisseurCF, getSuggestionCommande } from './cf.api';

export default defineComponent({
  components: {},
  setup() {
    const fournisseurs:Array<Object> = ref([]);
    const info:Object = ref({})
    const currentF:Object = ref({})
    const suggAll = ref(false)

    const headers: Header[] = [
        { text: "Réf", value: "refart", fixed: true,width:50},  // set fixed to true
        { text: "Désignation", value: "nom",width: 200},
        { text: "Four.", value: "CT_Num",width:50},
        { text: "Depot Stock", value: "do_statut",width:50},
        { text: "Qualité SEO", value: "seostars"},
        { text: "En vente ?", value: "statut",width: 50},
        { text: "Dispo four", value: "dispo_fournisseur",width: 50},
        { text: "Deb Liv", value: "debliv",width: 70},
        { text: "Fin Liv", value: "finliv",width: 70},
        { text: "Meth. Vente", value: "METHODE_VENTE"},
        { text: "P/P", value: "NB_PIECES_PAQUET",width: 50},  
        { text: "PCB", value: "PCB",width: 50 },  
        { text: "Stock à terme", value: "stockTermeSage",width:30},  
        { text: "Opé", value: "lastOPC",width: 70},  
        { text: "Opé à venir", value: "nextOPC",width: 70},  
        { text: "S-2 hors VP", value: "ventesLastWeek2",width: 50},  
        { text: "S-1 hors VP", value: "ventesLastWeek",width: 50},  
        { text: "Coef", value: "coef_progression",width: 70},  
        { text: "Stock cdé", value: "commandéSage",width: 50},  
        { text: "Qté suggérée", value: "suggestionQte",width: 60},  
        { text: "Qté Standbye", value: "standbye",width: 60},  
        { text: "Déjà consommé", value: "achats_saison",width: 60},  
        { text: "Reservé", value: "prev_saison",width: 50},  
        { text: "Ref Four", value: "AF_RefFourniss",width: 50},  
        { text: "Date Liv", value: "datelivrJour"},  
        { text: "Rotation", value: "rotation"},   
    ];
    const itemsSelected: Item[] = ref([]);
    const items: Item[] = ref([]);
    const loading = ref(true);

    async function getFournisseurs(){
        const [error , data] = await getFournisseurCF();
        if (error) console.error(error);
        else {
            fournisseurs.value = data;
            getCurrentFour('033');
        };
    }

    async function getInfoCF(four:String,sugg:Boolean){
        const [error , data] = await getSuggestionCommande(four,sugg);
       
        if (error) console.error(error);
        else {
            info.value = data;
            items.value = data.rows
            loading.value = false;
        };
    }

    function getCurrentFour(code:string){
      const __FOUND = fournisseurs.value.find(function(four, index) {
      if(four.codeFournisseur == code)
         currentF.value = four
      });
    }
    watch(
      () => currentF.value,
      async (newValue, oldValue) => {
        loading.value = true;
        await getInfoCF(newValue.codeFournisseur,suggAll.value)
        loading.value = false;
      }
    );
    watch(
      () => suggAll.value,
      async (newValue, oldValue) => {
        loading.value = true;
        await getInfoCF(currentF.codeFournisseur,newValue)
        loading.value = false;
      }
    );
    return {
      getCurrentFour,
      getFournisseurs,
      fournisseurs,
      currentF,
      suggAll,
      headers,
      loading,
      items,
      info,
      
    };
  },
  async created(){
       await this.getFournisseurs()
        
    }
});
</script>

<style scoped>
button{
    margin: 2px;
}
.customize-table {
  --easy-table-row-border: 1px solid #216155;

  --easy-table-header-font-size: 14px;
  --easy-table-header-height: 50px;
  --easy-table-header-font-color: #FFF;
  --easy-table-header-background-color: #216155;

  --easy-table-header-item-padding: 10px 15px;
  
}
#slideout {
		/* position: absolute; */
		position: fixed;
		top: 250PX;
		right: 0;
		width: 35px;
		-webkit-transition-duration: 0.3s;
		-moz-transition-duration: 0.3s;
		-o-transition-duration: 0.3s;
		transition-duration: 0.3s;
	}
	#slideout_tab {
		position: relative;
		top: 0;
		left: 0;
		padding: 12px 6px 12px 12px;
		text-align: center;
		background: #86B135;
		color: #fff;
		cursor:pointer;
		-webkit-border-radius: 5px 0 0 5px;
		-moz-border-radius: 5px 0 0 5px;
		border-radius: 5px 0 0 5px;
    width:100%
	}
	#slideout_inner {
    
		position: absolute;
		top: 0;
		left: 35px;
		background: #86B135;
		width: 250px;
		height: 51px;
		cursor:auto;
	}
	#showblock:checked + #slideout{right: 150px;}
	#showblock{display:none;}
</style>